<template>
  <v-dialog
    :value="value"
    max-width="290"
    @keydown.esc="closeRequest"
    @click:outside="closeRequest"
    content-class="round"
  >
    <div class="flex flex-col bg-white p-7 justify-between gap-8">
      <div class="flex-grox flex-row">
        <div class="text-xl font-semibold text-center">
          {{ title }}
        </div>
      </div>
      <div class="flex flex-col">
        <div>
          <div class="my-5 text-sm">
            <v-form
              lazy-validation
              ref="form"
              v-model="valid"
              @submit.prevent="onModalSubmit()"
            >
              <v-text-field
                label="Nom"
                id="nom"
                :rules="nomRules"
                required
                v-model="competence.nom"
              ></v-text-field>
            </v-form>
          </div>
        </div>
      </div>
      <div class="flex flex-row-reverse justify-between">
        <div>
          <button
            @click="onModalSubmit()"
            class="font-medium bg-bleu text-gray-50 text-sm py-2.5 px-5 rounded-lg hover:bg-bleuHover focus:outline-none"
          >
            {{ updating ? "Modifier" : "Ajouter" }}
          </button>
        </div>
        <div
          id="deleteMatCompSav"
          @click="onModalSubmit({ deleting: true })"
          class="cursor-pointer font-medium border border-red-400 text-red-400 text-sm py-2.5 px-5 rounded-lg hover:bg-red-400 hover:text-gray-50 focus:outline-none"
          v-show="updating"
        >
          Effacer
        </div>
      </div>
    </div>
  </v-dialog>
</template>

<script>
export default {
  emits: ["closeRequest, onModalSubmit"],

  props: {
    updatedCompetence: Object,
    forMatiere: { type: Object, required: false },
    value: Boolean,
  },

  methods: {
    closeRequest() {
      this.$emit("closeRequest");
    },

    onModalSubmit(deleting = false) {
      if (this.$refs.form.validate()) {
        if (deleting == false) {
          this.$store.dispatch("addCompetence", {
            ...this.competence,
            matiere: this.forMatiere,
          });
        } else this.$store.dispatch("deleteCompetence", this.competence);
        this.closeRequest();
      }
    },
  },

  data() {
    return {
      valid: false,
      updating: Object.keys(this.updatedCompetence).length != 0,
      competence: { ...this.updatedCompetence } ?? {},
      nomRules: [(v) => !!v || "Le nom est requis"],

      // bulletinRules: [(v) => !!v || "Le bulletin est requis"],
    };
  },

  computed: {
    title() {
      return this.updating
        ? `Modifier la compétence ${this.updatedCompetence.nom}`
        : `Ajouter une compétence à ${this.forMatiere.nom}`;
    },
  },
};
</script>
